/*
 * N.java
 *
 * Created on 16  2005 ., 20:58
 */

package Sc_pong;
import javax.microedition.lcdui.*;

/**
 *
 * @author scalan
 */
public class N 
    extends Canvas 
    implements CommandListener, Runnable {
    
    private Main d;
    private Command okCommand; // The save game command
    private Command backCommand; // The back command
    private boolean exitF = false;
    private Pong    pong;
    
    /** Creates a new instance of N */
    public N(Main d) {
        super();
        this.d = d;
        pong = new Pong(getWidth(), getHeight());
        backCommand = new Command("Back", Command.BACK,   3);
        okCommand   = new Command("Ok",   Command.BACK,   3);
        addCommand(backCommand);
        setCommandListener(this);
    }
    
    /*
     * repaint
     */
    protected void paintClipRect(Graphics g){
        int clipX = g.getClipX();
        int clipY = g.getClipY();
        int clipH = g.getClipHeight();
        int clipW = g.getClipWidth();
        
        int color = g.getColor();
        g.setColor(0xFF<<16 | 0xFF<<8 | 0xFF); // White
        g.fillRect(clipX, clipY, clipW, clipH);
        g.setColor(color); 
    }
    
    /**
     * paint
     */
    public void paint(Graphics g) {
        paintClipRect(g);
        pong.paint(g);
    }

    /**
     * Called when a key is pressed.
     */
    protected  void keyPressed(int keyCode) {
    }
    
    /**
     * Called when a key is released.
     */
    protected  void keyReleased(int keyCode) {
    }
        
    /**
     * Called when a key is repeated (held down).
     */
    protected  void keyRepeated(int keyCode) {
    }

    /**
     * Called when the pointer is dragged.
     */
    protected  void pointerDragged(int x, int y) {
    }
    
    /**
     * Called when the pointer is pressed.
     */
    protected  void pointerPressed(int x, int y) {
    }
    
    /**
     * Called when the pointer is released.
     */
    protected  void pointerReleased(int x, int y) {
    }
    
    /*
     * Respond to commands, including exit
     * On the exit command, cleanup and notify that the MIDlet has been destroyed.
     */

    public void commandAction(Command c, Displayable s) {
        if (c == backCommand || c == okCommand) {
            exitF = true;
//            Main.getInstance().display();
        }
    }

    public void run() {
        while(!exitF){
            pong.move();
            try{
                Thread.sleep(10);
            }
            catch(InterruptedException e){
            }
            repaint();  
        }
        addCommand(okCommand);
    }
}
